MODULE Hero; (* portable *)
IMPORT
  Grax, Rsrc := Resource, Timer,
  Keys := Keyboard;
CONST
  Speed = 1; (*    *)
VAR
  x, y, manDirX, manDirY: Grax.COORDS;

PROCEDURE GetUserControl (): Keys.KEY;
BEGIN
  IF Keys.Pressed(Keys.Up) THEN
    RETURN Keys.Up END;
  IF Keys.Pressed(Keys.Down) THEN
    RETURN Keys.Down END;
  IF Keys.Pressed(Keys.Left) THEN
    RETURN Keys.Left END;
  IF Keys.Pressed(Keys.Right) THEN
    RETURN Keys.Right END;
  RETURN Keys.NoKeys
END GetUserControl;

BEGIN
  x := 10; y := 10;
  (*   : *)
  LOOP (*  *)
    IF Keys.Pressed(Keys.Esc) THEN EXIT END;
    (*     *)
    CASE GetUserControl() OF (*   *)
      Keys.Up    : manDirX := 0; manDirY :=-1
    | Keys.Down  : manDirX := 0; manDirY := 1
    | Keys.Left  : manDirX :=-1; manDirY := 0
    | Keys.Right : manDirX := 1; manDirY := 0
    ELSE
      manDirX := 0; manDirY := 0
    END;
    Grax.PutSprite(x, y, Rsrc.None);
    x := x + manDirX; y := y + manDirY;
    (* ---------------------------- *)
    Grax.PutSprite(x, y, Rsrc.StopMan);
    Timer.DelayTicks(Speed);
    Grax.PutSprite(x, y, Rsrc.DownMan);
    Timer.DelayTicks(Speed);
    Grax.PutSprite(x, y, Rsrc.StopMan);
    Timer.DelayTicks(Speed);
    Grax.PutSprite(x, y, Rsrc.DownMan1);
    Timer.DelayTicks(Speed);
  END; (*  *)
  Keys.Close;
  Grax.Close
END Hero.

